2009-04-22 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* VBCodeCompiler.cs: better error when there's a problem running the
	specified exec.

2008-04-30  Gert Driesen  <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Fixed generated code for abstract properties.

2008-03-13  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* VBCodeGenerator.cs: Add quotes around the filename in ExternalSource
	  directives.

2008-01-27  Gert Driesen  <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: In GenerateDelegateInvokeExpression, only emit
	RaiseEvent statement on 2.0 profile if TargetObject is a
	CodeEventReferenceExpression. Spaces to tabs and code formatting.

2008-01-16  Gert Driesen  <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Implement support for type parameters.

2007-12-21  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* VBCodeGenerator.cs: Split array of keywords in two, one for 1.1 and one
	  for 2.0. Add some 2.0 specific keywords. When writing a type, escape the
	  name of the type if necessary. Output "Partial" if a type is partial.

2007-12-14  Rolf Bjarne Kvinge <RKvinge@novell.com>

	* VBCodeProvider.cs: Implement constructor added in 2.0SP1.

2007-10-30  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* VBCodeGenerator.cs: Fix array indexer expressions by don't adding a
	  ".Item" to the array.

2007-06-22  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* VBCodeCompiler.cs: Throw a descriptive exception if we're trying to
	  compile anything on the 1.0 profile. Correctly parse vbnc error
	  messages (and don't return any messages if there weren't any
	  errors/warnings). Fixes #81872.

2007-05-21  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* VBCodeCompiler.cs: Make sure there are spaces between all options in the command line arguments..

2007-05-17  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* VBCodeGenerator.cs: Add support for delegates with parameters, and misc fixes for event handling to match MS.

2007-05-17  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* VBCodeGenerator.cs: Always create escaped identifiers if the
	  identifier matches a keyword.

2007-05-08  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* VBCodeGenerator.cs: Don't add newlines when creating array creations expressions, fix the initial size expression and make sure a there's always {} somewhere.

2007-04-27  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* VBCodeCompiler.cs: In CompileFromFileBatch don't create error messages if compilation succeeded.

2007-04-16  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* VBCodeGenerator.cs: Small fix in GenerateBinaryOperatorExpression to always emit the IdentityInequality comparisons with Nothing in the same order (first object, then Nothing).

2007-04-16  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* VBCodeCompiler.cs: In CreateErrorFromString don't return null if the message couldn't be parsed. Temporary fix for ASP.Net to show more helpful fail messages. In CompileFromFileBatch don't try to load the assembly if the compilation returned a non-zero exit code.

2007-04-13  Frederik Carlier  <frederik.carlier@carlier-online.be>

	* VBCodeGenerator.cs: Added support for the IdentityInequality operator when comparing against Nothing.

2007-03-09  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* VBCodeCompiler.cs: Reference Microsoft.VisualBasic.dll and not Microsoft.VisualBasic (patch by Frederik Carlier). 
	Don't set /wlevel, vbnc doesn't support it.

2007-02-21  Gert Driesen  <drieseng@users.sourceforge.net>

	* VBCodeCompiler.cs: Also generate temp filename if OutputAssembly is
	zero-length string. Fixed bug #80920 for VB.
	* VBCodeGenerator.cs: To match MS, do not emit empty parentheses when
	calling base ctor without arguments.

2007-02-20  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* VBCodeCompiler.cs: Replace mbas with vbnc. Don't send '--' to the
	compiler, since vbnc doesn't support it.

2006-04-20  Gert Driesen  <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Empty line and comments should be output after 
	namespace imports.

2006-02-14  Rafael Teixeira <rafaelteixeirabr@hotmail.com> 
	* VBCodeCompiler.cs: 
		use mbas.exe from 1.0 or 2.0, depending on NET_2_0
		BuildArgs()
			copy options.CompilerOptions to the resulting command line  (as pointed by Arnhoffer Károly)	
			use Append instead of AppendFormat when possible
			
2005-12-07  Gert Driesen  <drieseng@users.sourceforge.net>

	* VBCodeCompiler.cs: Set eol-style to native.
	* VBCodeGenerator.cs: Set eol-style to native.
        * VBCodeProvider.cs: Set eol-style to native.


2005-12-07  Gert Driesen  <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Modified GeneratePrimitiveExpression to match
	.NET 1.x and 2.0 for char, float, ushort, uint, ulong and sbyte.

2005-11-30  Gert Driesen  <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Fixed NRE in GenerateEventReferenceExpression,
	and escape event name. Indent statements for iteration. Avoid
	ArgumentNullException if expression is not set for CodeReturnStatement.
	Temporary reduce indentation for label, and fixed ArgumentNullException
	if no statement is set. Cosmetic changes to code generated for 
	condition to match MS.NET. In OutputTypeNamePair, escape name.

2005-11-26  Gert Driesen  <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Fixed NullReferenceException if no ToThrow
	expression is set for CodeThrowExceptionStatement. Fixed
	GenerateComment to output comment chars for carriage-returns and
	linefeed characters. Modified code generated for
	CodeTryCatchFinallyStatement to match MS.NET. Fixed code generated
	for CodeGotoStatement to match MS.NET. On 2.0 profile, output
	"__exception" if name is zero-length string in OutputTypeNamePair.

2005-10-29  Sebastien Pouliot  <sebastien@ximian.com>

	* VBCodeProvider.cs: GenerateCodeFromMember method is an override in 
	2.0 final.

2005-10-28  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Use fixed signature for entrypoint method.
	Only output attributes on 2.0 profile. Replace + with dot in type 
	name (for nested types). Fixes bug #76580.

2005-10-25  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Do not output name of CodeAttributeArgument if
	its a zero-length string.

2005-10-19  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* VBCodeGenerator.cs: Generate MyBase.New() with parenthesis as mbas currently chokes without them 
	
2005-10-17  Sebastien Pouliot  <sebastien@ximian.com>

	* VBCodeProvider.cs: Added a LinkDemand and an InheritanceDemand
	for FullTrust (i.e. Unrestricted permission set) at the class level.
	Added [Obsolete] on CreateCompiler and CreateGenerator methods (2.0).
	Stubbed new method GenerateCodeFromMember (2.0).

2006-07-30  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Fixed code generated for NewSlot members.

2005-07-24  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Fixed generated code for enums, interfaces and
	delegates to match MS.NET.

2005-07-02  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Added support for ReturnTypeCustomAttributes.

2005-07-02  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Scope modifiers should not be output for
	events.

2005-07-02  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Added PrivateImplementationType support for
	properties, methods and event (2.0 only). Added Overloads support
	for properties and methods.

2005-07-01  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Added ImplementationTypes support for
	properties and events, and fixed support for methods.

2005-06-30  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Mark indexer as default property.

2005-06-27  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Added short type names for which support was
	added in .NET 2.0. Added support for Date. 

2005-06-26  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Minor fixes for compatibility with MS.NET 2.0.

2005-06-26  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Fixed generated code for attributes on ctors.
	Implemented Base/Chained ctor args.

2005-06-26  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Fixed generated code for method, property
	and parameter level attributes. Fixed code generated for
	FieldDirection.

2005-06-25  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Removed type shortcuts that are not valid for
	VB.NET. Fixed generated code for event and field level attributes.
	Don't output Overridable for events. 

2005-06-25  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: Modified generated code for type-level
	attributes to match MS.NET.

2005-06-25  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeGenerator.cs: No longer implictly add import for 
	Microsoft.VisualBasic namespace to match MS.NET. Several fixes
	in order to have generated code match that generated by MS
	(backed by unit tests).

2005-06-13  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeCompiler.cs: Temp source files should have extension ".vb".

2005-06-09  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeCompiler.cs: ArgumentException was thrown when more than 
	one file/source or CodeCompileUnit is built, temporary files were
	not cleaned up. Fixes bug #75191.

2005-05-29  Gert Driesen <drieseng@users.sourceforge.net>

	* VBCodeCompiler.cs: Load compiled assembly from byte array if
	GenerateInMemory compiler parameter is set, set PathToAssembly
	if compilation succeeded and GenerateInMemory is false.
	Fixes bug #74959.

2005-04-20  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* VBCodeGenerator.cs: Better logic for OptionStrict/Explicit generation

2004-12-27  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* VBCodeCompiler.cs: Added /quiet argument to avoid the "Alpha message"
	
2004-08-21  Jochen Wezel <jwezel@compumaster.de>
	* VBCodeGenerator.cs: Removed some indentation commenting in generated
	  source code

2004-08-09  Jambunathan K  <kjambunathan@novell.com>
	* VBCodeCompiler.cs: Regex pattern in CreateErrorFromString() now
	  reads (?<level>error|warning) instead of (?<level>\w*). This is
	  so that mbas's ALPHA message doesn't get captured as a error
	  string.

2004-06-28  Atsushi Enomoto  <atsushi@ximian.com>

	* VBCodeCompiler.cs : (only for windows) First check mono.bat, then
	  check mono.exe. It enables xsp working with mono windows installer.

2004-06-24  Atsushi Enomoto <atsushi@ximian.com>

	* VBCodeCompiler.cs : On windows we use fixed mono.exe and mbas.exe
	  located by mscorlib.dll. (The same fix as that of CSharpCodeCompiler)

2004-06-03  Jochen Wezel <jwezel@compumaster.de>

	* VBCodeGenerator.cs: MemberAttributes made more compatible to MS
        style (e. g. NotOverridable), Properties ReadOnly/WriteOnly fixed,
	Property Set fixed, successless analysis of wrong indentation of last 
	line which contains "End Namespace" (should be on the very left)

2004-04-26  Jochen Wezel <jwezel@compumaster.de>

	* VBCodeGenerator.cs: GenerateAttributeDeclarationsEnd: Fix of line break

2004-02-10  Jackson Harper <jackson@ximian.com>

	* VBCodeCompiler.cs: Use the temp files collection for
	creating temp files.
	
2004-02-05  Jackson Harper <jackson@ximian.com>

	* VBCodeCompiler.cs: Set file extensions properly.
	
2003-11-27  Rafael Teixeira <rafaelteixeirabr@hotmail.com>

	* Microsoft.VisualBasic/VBCodeGenerator.cs: Support for Option Strict/Option Explicit
	
2003-11-27  Jackson Harper <jackson@ximian.com>

	* VBCodeCompiler.cs: Put a space between Property and the
	properties name. Only add a closing quote to strings if we are
	still in a quote. Use BaseType == "System.Void" to determine if a
	method is void. This prevents getting As Nothing functions. Many
	thanks to Anirban for helping me with VB Syntax.
	
2003-11-27  Jackson Harper <jackson@ximian.com>

	* VBCodeCompiler.cs: use /wlevel for warning level. This is what
	mbas uses.
	
2003-11-06  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* VBCodeGenerator.cs: some corrections regarding missing spaces in
	generated code (e. g. "Property "). QuoteSnippetString implemented.
	Patch by Jochen Wezel (jwezel@compumaster.de).

2003-10-17  Rafael Teixeira <rafaelteixeirabr@hotmail.com>

	* Microsoft.VisualBasic/VBCodeGenerator.cs: Sub or Function generation
	is switched by method.ReturnType being "System.Void"

2003-10-17  Rafael Teixeira <rafaelteixeirabr@hotmail.com>

	* Microsoft.VisualBasic/VBCodeCompiler.cs: Inserts "--" before file
	names block
	* Microsoft.VisualBasic/VBCodeGenerator.cs: Indexer should be
	".Item(xx)"

2003-10-14  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Microsoft.VisualBasic/VBCodeCompiler.cs: New.
	* Microsoft.VisualBasic/VBCodeGenerator.cs:
	* Microsoft.VisualBasic/VBCodeProvider.cs: modified others to use the
	new CodeCompiler.

	New VBCodeCompiler by Jochen Wezel <jwezel@compumaster.de>.


2003-07-07  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* VBCodeProvider.cs: Removed unneccesary attributes according to
	corecompare

2003-06-25  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* VBCodeGenerator.cs: Added and nearly completely implemented
		(it compiles, but the functionallity is completely untested)
		(also without a working mbas the compilaton options will fail)
		(once all command line arguments for mbas are final and the
		warning output is final change the apropriate code to generate
		these options)

	* VBCodeProvider.cs: Added and implemented
